plugins {
    `java-library`
    `maven-publish`
}

repositories {
    mavenCentral()
    maven("https://maven.frohnmeyer-wds.de/artifacts")
}

dependencies {
    compileOnly("org.jetbrains:annotations:23.0.0")
}

publishing {
    repositories {
        mavenLocal()

        if (rootProject.extra["isPublic"] == true) {
            maven("https://maven.frohnmeyer-wds.de/artifacts") {
                name = "public"

                credentials(PasswordCredentials::class) {
                    username = System.getenv()["MAVEN_NAME"]
                    password = System.getenv()["MAVEN_TOKEN"]
                }
                authentication {
                    create<BasicAuthentication>("basic")
                }
            }
        }
    }
}