package io.gitlab.jfronny.inceptum.launcher.model.curseforge;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;
import io.gitlab.jfronny.inceptum.common.GsonPreset;

import java.util.Set;

@GSerializable(configure = GsonPreset.Api.class)
public record CurseforgeModpackManifest(Minecraft minecraft,
                                        String manifestType,
                                        int manifestVersion,
                                        String name,
                                        String version,
                                        String author,
                                        Set<File> files,
                                        String overrides) {
    @GSerializable(configure = GsonPreset.Api.class)
    public record Minecraft(String version, Set<ModLoader> modLoaders) {
        @GSerializable(configure = GsonPreset.Api.class)
        public record ModLoader(String id, boolean primary) {
        }
    }

    @GSerializable(configure = GsonPreset.Api.class)
    public record File(int projectID, int fileID, boolean required) {
    }
}
