package io.gitlab.jfronny.inceptum.launcher.model.curseforge.response;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;
import io.gitlab.jfronny.inceptum.common.GsonPreset;
import io.gitlab.jfronny.inceptum.launcher.model.curseforge.CurseforgeFile;

import java.util.List;

@GSerializable(configure = GsonPreset.Api.class)
public record FingerprintMatchesResponse(Result data) {
    @GSerializable(configure = GsonPreset.Api.class)
    public record Result(boolean isCacheBuilt,
                         List<Match> exactMatches,
                         List<Integer> exactFingerprints,
                         List<Match> partialMatches,
                         List<Integer> installedFingerprints,
                         List<Integer> unmatchedFingerprints) {
        @GSerializable(configure = GsonPreset.Api.class)
        public record Match(int id, CurseforgeFile file, List<CurseforgeFile> latestFiles) {
        }
    }
}
