package io.gitlab.jfronny.inceptum.launcher.model.modrinth;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;
import io.gitlab.jfronny.inceptum.common.GsonPreset;

import java.util.Date;
import java.util.List;

@GSerializable(configure = GsonPreset.Api.class)
public record ModrinthSearchResult(List<ModResult> hits, int offset, int limit, int total_hits) {
    @GSerializable(configure = GsonPreset.Api.class)
    public record ModResult(
            String project_id,
            ModrinthProjectType project_type,
            String slug,
            String author,
            String title,
            String description,
            List<String> categories,
            List<String> versions,
            long downloads,
            long follows,
            String icon_url,
            Date date_created,
            Date date_modified,
            String latest_version,
            String license,
            String client_side,
            String server_side,
            List<String> gallery
    ) {
    }
}
