package io.gitlab.jfronny.inceptum.launcher.util;

public class GameVersionParser {
    private static final String FABRIC_PREFIX = "fabric-loader-";

    public static boolean isFabric(String version) {
        return version.startsWith(FABRIC_PREFIX);
    }

    public static String getGameVersion(String version) {
        return version.startsWith(FABRIC_PREFIX) ? version.substring(version.lastIndexOf('-') + 1) : version;
    }

    public static String getLoaderVersion(String version) {
        return !isFabric(version) ? null : version.substring(FABRIC_PREFIX.length(), version.lastIndexOf('-'));
    }

    public static String createVersionWithFabric(String gameVersion, String fabricVersion) {
        return FABRIC_PREFIX + fabricVersion + '-' + gameVersion;
    }
}
